#include <stdio.h>
#include <string.h>
#include <gl/glut.h>

#define min(a,b)	((a)<(b) ? (a) : (b))
#define max(a,b)	((a)>(b) ? (a) : (b))

#define MAX_X 550
#define MAX_Y 450
#define MAX_VRHOVA 50
#define MAX_UNOS 50

int	broj_vrhova;
int	vrh_x[MAX_VRHOVA+1], vrh_y[MAX_VRHOVA+1];
float	a[MAX_VRHOVA], b[MAX_VRHOVA], c[MAX_VRHOVA];
int	tocka_x, tocka_y;

char	unos_broja[MAX_UNOS];
char	unos_vrha[MAX_VRHOVA][MAX_UNOS];
char	unos_tocke[MAX_UNOS];
char	*trenutni_unos;

void	obradaPrikaza (void);
void	obradaTipke (unsigned char tipka, int x, int y);
void	obradaMisa (int gumb, int stanje, int x, int y);
void	prikazTeksta (int x, int y, char *string1, char *string2);
void	citanjeDatoteke (char *datoteka);


void obradaPrikaza (void)
{
	int y, y_min, y_max, izvan, i;
	float L, D, x1;

	glClear (GL_COLOR_BUFFER_BIT);
	glColor3f (0.5, 0.5, 0.5);
	
	prikazTeksta (10, MAX_Y-13, "Molim broj vrhova poligona: ", unos_broja);
	if (trenutni_unos != unos_broja)
		for (i=0; i<broj_vrhova; i++) {
			prikazTeksta (10, MAX_Y-(26+i*13), "Molim koordinate vrha: ", unos_vrha[i]);
			if (trenutni_unos == unos_vrha[i]) break;
		}
	if (trenutni_unos == unos_tocke || trenutni_unos == NULL) {
		prikazTeksta (10, MAX_Y-(MAX_Y-6-13), "Molim koordinate ispitne tocke: ", unos_tocke);

		glColor3f (0.8, 0.8, 0.8);
		for (i=0; i<broj_vrhova; i++) {
			a[i] = vrh_y[i] - vrh_y[i+1];
			b[i] = - vrh_x[i] + vrh_x[i+1];
			c[i] = (float) vrh_x[i] * vrh_y[i+1] - vrh_x[i+1] * vrh_y[i];
			y_min = (i > 0 ? min (y_min, vrh_y[i]) : vrh_y[i]);
			y_max = (i > 0 ? max (y_max, vrh_y[i]) : vrh_y[i]);
		}
		for (y=y_min; y<y_max; y++) {
			L = -1000000;
			D = 1000000;
			for (i=0; i<broj_vrhova; i++) {
				if (a[i] == 0)
					continue;
				x1 = - b[i] * y / a[i] - c[i] / a[i];
				if (vrh_y[i] < vrh_y[i+1] && x1 > L)
					L = x1;
				if (vrh_y[i] >= vrh_y[i+1] && x1 < D)
					D = x1;
			}
			if (L < D) {
				glBegin (GL_LINES);
				glVertex2f (L, y);
				glVertex2f (D, y);
				glEnd ();
			}
		}
		glColor3f (0.0, 0.0, 0.0);
		glBegin (GL_LINE_LOOP);
		for (i=0; i<broj_vrhova; i++)
			glVertex2i (vrh_x[i], vrh_y[i]);
		glEnd ();
	}

	if (trenutni_unos == NULL) {
		izvan = 0;
		for (i=0; i<broj_vrhova; i++) {
			if (tocka_x * a[i] + tocka_y * b[i] + c[i] > 0)
				izvan = 1;
		}
		if (izvan)
			prikazTeksta (10, MAX_Y-(MAX_Y-6), "TOCKA JE IZVAN POLIGONA.", NULL);
		else
			prikazTeksta (10, MAX_Y-(MAX_Y-6), "TOCKA JE UNUTAR POLIGONA.", NULL);
	}

	glutSwapBuffers ();
}


void prikazTeksta (int x, int y, char *string1, char *string2)
{  
	char *c;

	glPushMatrix ();
	glRasterPos2i (x, y);
	for (c=string1; *c != '\0'; c++)
		glutBitmapCharacter (GLUT_BITMAP_8_BY_13, *c);
	for (c=string2; c && *c != '\0'; c++)
		glutBitmapCharacter (GLUT_BITMAP_8_BY_13, *c);
	if (string2 && string2 == trenutni_unos)
		glutBitmapCharacter (GLUT_BITMAP_8_BY_13, '_');
	glPopMatrix ();
}


void obradaTipke (unsigned char tipka, int x, int y)
{
	int i;

	if (trenutni_unos != NULL) {
		if (((tipka >= '0' && tipka <= '9') || tipka == ' ') && strlen (trenutni_unos) < MAX_UNOS-1) {
			trenutni_unos[strlen(trenutni_unos)+1] = 0;
			trenutni_unos[strlen(trenutni_unos)] = tipka;
			glutPostRedisplay ();
		}
		if (tipka == 8 && *trenutni_unos) {
			trenutni_unos[strlen(trenutni_unos)-1] = 0;
			glutPostRedisplay ();
		}
		if (tipka == 13) {
			if (trenutni_unos == unos_tocke) {
				if (sscanf (unos_tocke, "%d %d", &tocka_x, &tocka_y) == 2 && tocka_x >= 0 && tocka_x <= MAX_X && tocka_y >= 0 && tocka_y <= MAX_Y)
					trenutni_unos = NULL;
			}
			for (i=0; i<broj_vrhova; i++)
				if (trenutni_unos == unos_vrha[i]) {
					if (sscanf (unos_vrha[i], "%d %d", &vrh_x[i], &vrh_y[i]) == 2 && vrh_x[i] >= 0 && vrh_x[i] <= MAX_X && vrh_y[i] >= 0 && vrh_y[i] <= MAX_Y) {
						trenutni_unos = (i < broj_vrhova-1 ? unos_vrha[i+1] : unos_tocke);
						if (i == broj_vrhova-1) {
							vrh_x[broj_vrhova] = vrh_x[0];
							vrh_y[broj_vrhova] = vrh_y[0];
						}
					}
					break;
				}
			if (trenutni_unos == unos_broja) {
				if (sscanf (unos_broja, "%d", &broj_vrhova) == 1 && broj_vrhova >= 3 && broj_vrhova <= MAX_VRHOVA)
					trenutni_unos = unos_vrha[0];
			}
			if (trenutni_unos != NULL)
				*trenutni_unos = 0;
			glutPostRedisplay ();
		}
	}
}


void obradaMisa (int gumb, int stanje, int x, int y)
{
	int i;
	y = MAX_Y - y;

	if (gumb == GLUT_LEFT_BUTTON && stanje == GLUT_DOWN) {
		if (trenutni_unos == unos_tocke || trenutni_unos == NULL) {
			sprintf (unos_tocke, "%d %d", x, y);
			tocka_x = x;
			tocka_y = y;
			trenutni_unos = NULL;
			glutPostRedisplay ();
		}
		for (i=0; i<broj_vrhova; i++)
			if (trenutni_unos == unos_vrha[i]) {
				sprintf (unos_vrha[i], "%d %d", x, y);
				vrh_x[i] = x;
				vrh_y[i] = y;
				if (i == broj_vrhova-1) {
					vrh_x[broj_vrhova] = vrh_x[0];
					vrh_y[broj_vrhova] = vrh_y[0];
				}
				trenutni_unos = (i < broj_vrhova-1 ? unos_vrha[i+1] : unos_tocke);
				*trenutni_unos = 0;
				glutPostRedisplay ();
				break;
			}
	}

	if (gumb == GLUT_RIGHT_BUTTON && stanje == GLUT_DOWN) {
		broj_vrhova = 0;
		trenutni_unos = unos_broja;
		*trenutni_unos = 0;
		glutPostRedisplay ();
	}
}


void citanjeDatoteke (char *datoteka)
{
	FILE *f;
	char s[MAX_UNOS+1];
	int i = 0;

	f = fopen (datoteka, "r");
	if (!f) return;
	if (fgets (s, MAX_UNOS, f) == s && sscanf (s, "%d", &i) == 1) {
		if (i < 3) return;
		trenutni_unos = unos_vrha[0];
		while (i-- && broj_vrhova < MAX_VRHOVA && fgets (s, MAX_UNOS, f) == s)
			if (sscanf (s, "%d %d", &vrh_x[broj_vrhova], &vrh_y[broj_vrhova]) == 2) {
				sprintf (unos_vrha[broj_vrhova], "%d %d", vrh_x[broj_vrhova], vrh_y[broj_vrhova]);
				broj_vrhova++;
				trenutni_unos = unos_vrha[broj_vrhova];
			}
		sprintf (unos_broja, "%d", broj_vrhova);
		if (i <= 0  ||  broj_vrhova == MAX_VRHOVA)
			trenutni_unos = unos_tocke;
		if (fgets (s, MAX_UNOS, f) == s && sscanf (s, "%d %d", &tocka_x, &tocka_y) == 2) {
			sprintf (unos_tocke, "%d %d", tocka_x, tocka_y);
			trenutni_unos = NULL;
		}
	}
	if (trenutni_unos)
		*trenutni_unos = 0;
	fclose (f);
}


void main (int argc, char *argv[])
{
	broj_vrhova = 0;
	trenutni_unos = unos_broja;
	*trenutni_unos = 0;

	if (argc >= 2)
		citanjeDatoteke (argv[1]);

	glutInit (&argc, argv);
	glutInitDisplayMode (GLUT_DOUBLE);
	glutInitWindowPosition (100,100);
	glutInitWindowSize (MAX_X+1, MAX_Y+1);
	glutCreateWindow ("Laboratorijska vjezba 2");

	glOrtho (0, MAX_X, 0, MAX_Y, 0, 1); 
	glClearColor (1.0, 1.0, 1.0, 1.0);
	glClear (GL_COLOR_BUFFER_BIT);

	glutDisplayFunc (obradaPrikaza);
	glutKeyboardFunc (obradaTipke);
	glutMouseFunc (obradaMisa);
	glutMainLoop ();
}
